<template>
  <el-button @click="onShow">Edit</el-button>

  <teleport to="body">
    <el-dialog title="Edit city" v-model="dialogVisible" :before-close="cancel">
      <el-form
        :model="form"
        ref="edit-form"
        :rules="rules"
        @validate="onValidate"
        @submit="submit"
      >
        <el-form-item prop="name" label="Name">
          <el-input v-model="form.name"></el-input>
        </el-form-item>
        <el-form-item prop="photo" label="Photo">
          <el-input v-model="form.photo"></el-input>
        </el-form-item>
      </el-form>
      <template #footer>
        <span class="dialog-footer">
          <el-button @click="cancel">Cancel</el-button>
          <el-button type="primary" @click="submit">Ok</el-button>
        </span>
      </template>
    </el-dialog>
  </teleport>
</template>

<script lang="ts">
import type { PropType } from "vue";
import { defineComponent } from "vue";
import { isConstraintViolation, isProblem } from "@/util";
import type { City, CityUpdateDto } from "@/api";
import {
  type ElementForm,
  httpLinkFormat,
  InputLength,
  inputRequired,
} from "@/validation";

export default defineComponent({
  name: "CityEditDialog",
  props: {
    city: {
      type: Object as PropType<City>,
      required: true,
    },
    onOk: {
      type: Function,
      required: true,
    },
  },
  data() {
    return {
      dialogVisible: false,
      form: {} as City,
      rules: {
        name: [new InputLength(255), inputRequired],
        photo: [new InputLength(1000), httpLinkFormat],
      },
      isFormValid: true,
    };
  },
  methods: {
    cancel() {
      this.dialogVisible = false;
      this.form = {} as CityUpdateDto;
    },
    async submit() {
      const form = this.$refs["edit-form"] as ElementForm;
      if (await form.validate()) {
        try {
          await this.onOk(this.city.id, this.form);
          this.$notify.info("City updated");
        } catch (e) {
          if (isConstraintViolation(e)) {
            e.violations.forEach((violation: { message: string }) =>
              this.$notify.error(violation.message)
            );
          } else if (isProblem(e)) {
            this.$notify.error(e.detail);
          }
        }
      }
      this.$emit("update");
      this.cancel();
    },
    onValidate(prop: string, isVal: boolean) {
      this.isFormValid = isVal;
    },
    onShow(): void {
      this.dialogVisible = true;
      this.form = { ...this.city };
    },
  },
});
</script>
